precision mediump float;

varying vec2 vTextureCoord;
uniform sampler2D uTexture;

uniform float uOffsetX;
uniform float uOffsetY;

void main()
{
	vec4 color = vec4(0.0);
	vec2 minVec = vec2(0.0, 0.0);
	vec2 maxVec = vec2(1.0, 1.0);

	// Sample top left pixel
	color += texture2D(uTexture, clamp(vec2(vTextureCoord.x - uOffsetX, vTextureCoord.y + uOffsetY), minVec, maxVec));

	// Sample top right pixel
	color += texture2D(uTexture, clamp(vec2(vTextureCoord.x + uOffsetX, vTextureCoord.y + uOffsetY), minVec, maxVec));

	// Sample bottom right pixel
	color += texture2D(uTexture, clamp(vec2(vTextureCoord.x + uOffsetX, vTextureCoord.y - uOffsetY), minVec, maxVec));

	// Sample bottom left pixel
	color += texture2D(uTexture, clamp(vec2(vTextureCoord.x - uOffsetX, vTextureCoord.y - uOffsetY), minVec, maxVec));

	// Average
	color *= 0.25;

	gl_FragColor = color;
}