precision mediump float;

varying vec2 vTextureCoord;
uniform sampler2D uTexture;

uniform float uOffsetX;
uniform float uOffsetY;

void main()
{
    vec4 color = vec4(0.0);

    // Sample top left pixel
    color += texture2D(uTexture, vec2(vTextureCoord.x - uOffsetX, vTextureCoord.y + uOffsetY));

    // Sample top right pixel
    color += texture2D(uTexture, vec2(vTextureCoord.x + uOffsetX, vTextureCoord.y + uOffsetY));

    // Sample bottom right pixel
    color += texture2D(uTexture, vec2(vTextureCoord.x + uOffsetX, vTextureCoord.y - uOffsetY));

    // Sample bottom left pixel
    color += texture2D(uTexture, vec2(vTextureCoord.x - uOffsetX, vTextureCoord.y - uOffsetY));

    // Average
    color *= 0.25;

    gl_FragColor = color;
}