precision lowp float;

varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform float intensity;
uniform vec3 firstColor;
uniform vec3 secondColor;

const mediump vec3 luminanceWeighting = vec3(0.2125, 0.7154, 0.0721);

vec4 duotone(vec4 colorIn) {
    float luminance = dot(colorIn.rgb, luminanceWeighting);
    lowp vec4 outputColor = vec4( mix(firstColor.rgb, secondColor.rgb, luminance), colorIn.a);
    return vec4( mix(colorIn.rgb, outputColor.rgb, intensity), colorIn.a);
}

void main()
{
    lowp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    gl_FragColor = duotone(textureColor);
}

